std::reverse_iterator< _Iterator >(3cxx)

NAME
std::reverse_iterator< _Iterator >

SYNOPSIS

Inherits std::iterator< iterator_traits< _Iterator >::iterator_category, iterator_traits< _Iterator >::value_type, iterator_traits< _Iterator >::difference_type, iterator_traits< _Iterator >::pointer, iterator_traits< _Iterator >::reference >.

  Public Types

typedef __traits_type::difference_type difference_type
typedef iterator_traits< _Iterator >::iterator_category iterator_category
One of the tag types.
typedef _Iterator iterator_type
typedef __traits_type::pointer pointer
typedef __traits_type::reference reference
typedef iterator_traits< _Iterator >::value_type value_type
The type 'pointed to' by the iterator.

  Public Member Functions

constexpr reverse_iterator ()
constexpr reverse_iterator (const reverse_iterator &__x)
template<typename _Iter > constexpr reverse_iterator (const reverse_iterator< _Iter > &__x)
constexpr reverse_iterator (iterator_type __x)
constexpr iterator_type base () const
constexpr reference operator* () const
constexpr reverse_iterator operator+ (difference_type __n) const
constexpr reverse_iterator & operator++ ()
constexpr reverse_iterator operator++ (int)
constexpr reverse_iterator & operator+= (difference_type __n)
constexpr reverse_iterator operator- (difference_type __n) const
constexpr reverse_iterator & operator-- ()
constexpr reverse_iterator operator-- (int)
constexpr reverse_iterator & operator-= (difference_type __n)
constexpr pointer operator-> () const
reverse_iterator & operator= (const reverse_iterator &)=default
template<typename _Iter > constexpr reverse_iterator & operator= (const reverse_iterator< _Iter > &__x)
constexpr reference operator[] (difference_type __n) const

  Protected Types

typedef iterator_traits< _Iterator > __traits_type

  Protected Attributes

_Iterator current

Detailed Description

  template<typename _Iterator>
class std::reverse_iterator< _Iterator >" Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator i is established by the identity:

&*(reverse_iterator(i)) == &*(i - 1)

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array. [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Member Typedef Documentation

  typedef iterator_traits< _Iterator >::iterator_category std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::iterator_category [inherited]

One of the tag types.

  typedef iterator_traits< _Iterator >::value_type std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::value_type [inherited]

The type 'pointed to' by the iterator.

Constructor & Destructor Documentation

  template<typename _Iterator > constexpr std::reverse_iterator< _Iterator >::reverse_iterator () [inline], [constexpr]
The default constructor value-initializes member current. If it is a pointer, that means it is zero-initialized.

  template<typename _Iterator > constexpr std::reverse_iterator< _Iterator >::reverse_iterator (iterator_type __x) [inline], [explicit], [constexpr]
This iterator will move in the opposite direction that x does.

  template<typename _Iterator > constexpr std::reverse_iterator< _Iterator >::reverse_iterator (const reverse_iterator< _Iterator > & __x) [inline], [constexpr]
The copy constructor is normal.

  template<typename _Iterator > template<typename _Iter > constexpr std::reverse_iterator< _Iterator >::reverse_iterator (const reverse_iterator< _Iter > & __x) [inline], [constexpr]
A reverse_iterator across other types can be copied if the underlying iterator can be converted to the type of current.

Member Function Documentation

  template<typename _Iterator > constexpr iterator_type std::reverse_iterator< _Iterator >::base () const [inline], [constexpr]

Returns
    current, the iterator used for underlying work.

  template<typename _Iterator > constexpr reference std::reverse_iterator< _Iterator >::operator* () const [inline], [constexpr]

Returns
    A reference to the value at --current

This requires that --current is dereferenceable.

Warning
    This implementation requires that for an iterator of the underlying iterator type, x, a reference obtained by *x remains valid after x has been modified or destroyed. This is a bug: http://gcc.gnu.org/PR51823

  template<typename _Iterator > constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator+ (difference_type __n) const [inline], [constexpr]

Returns
    A reverse_iterator that refers to current - __n

The underlying iterator must be a Random Access Iterator.

  template<typename _Iterator > constexpr reverse_iterator& std::reverse_iterator< _Iterator >::operator++ () [inline], [constexpr]

Returns
    *this

Decrements the underlying iterator.

  template<typename _Iterator > constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator++ (int) [inline], [constexpr]

Returns
    The original value of *this

Decrements the underlying iterator.

  template<typename _Iterator > constexpr reverse_iterator& std::reverse_iterator< _Iterator >::operator+= (difference_type __n) [inline], [constexpr]

Returns
    *this

Moves the underlying iterator backwards __n steps. The underlying iterator must be a Random Access Iterator.

  template<typename _Iterator > constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator- (difference_type __n) const [inline], [constexpr]

Returns
    A reverse_iterator that refers to current - __n

The underlying iterator must be a Random Access Iterator.

  template<typename _Iterator > constexpr reverse_iterator& std::reverse_iterator< _Iterator >::operator-- () [inline], [constexpr]

Returns
    *this

Increments the underlying iterator.

  template<typename _Iterator > constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator-- (int) [inline], [constexpr]

Returns
    A reverse_iterator with the previous value of *this

Increments the underlying iterator.

  template<typename _Iterator > constexpr reverse_iterator& std::reverse_iterator< _Iterator >::operator-= (difference_type __n) [inline], [constexpr]

Returns
    *this

Moves the underlying iterator forwards __n steps. The underlying iterator must be a Random Access Iterator.

  template<typename _Iterator > constexpr pointer std::reverse_iterator< _Iterator >::operator-> () const [inline], [constexpr]

Returns
    A pointer to the value at --current

This requires that --current is dereferenceable.

  template<typename _Iterator > constexpr reference std::reverse_iterator< _Iterator >::operator[] (difference_type __n) const [inline], [constexpr]

Returns
    The value at current - __n - 1

The underlying iterator must be a Random Access Iterator.

Author

Generated automatically by Doxygen for libstdc++ from the source code.